## Create a Snapshot

### Request

**POST** `/v2.0/snapshots`

### Example cURL Request

```bash
curl --request POST \
  --url https://api-trial.cognigy.ai/new/v2.0/snapshots \
  --header 'Content-Type: application/json' \
  --header 'X-API-Key: <api-key>' \
  --data '
{
  "name": "New Snapshot",
  "description": "Version 1",
  "projectId": "<string>"
}
'```

### Example with Python

```python
import requests

url = "https://api-trial.cognigy.ai/new/v2.0/snapshots"

payload = {
    "name": "New Snapshot",
    "description": "Version 1",
    "projectId": "<string>"
}
headers = {
    "X-API-Key": "<api-key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### Example with JavaScript (Fetch API)

```javascript
const options = {
  method: 'POST',
  headers: {'X-API-Key': '<api-key>', 'Content-Type': 'application/json'},
  body: JSON.stringify({name: 'New Snapshot', description: 'Version 1', projectId: '<string>'})
};

fetch('https://api-trial.cognigy.ai/new/v2.0/snapshots', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### Example with PHP

```php
$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api-trial.cognigy.ai/new/v2.0/snapshots",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'name' => 'New Snapshot',
    'description' => 'Version 1',
    'projectId' => '<string>'
  ]),
  CURLOPT_HTTPHEADER => [
    "Content-Type: application/json",
    "X-API-Key: <api-key>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

### URI and Response

**Responses:**
- **202** - Task to create the Snapshot successfully created.
- **400** - Bad Request - Validation failed. Missing payload.
- **401** - Unauthorized - Invalid API Key.
- **402** - Payment Required - Validation failed. Missing payload.
- **403** - Forbidden - Access denied.

### Successful Response Example

```json
{
  "_id": "<string>",
  "status": "queued",
  "type": "trainIntents",
  "parameters": {},
  "lastChangedAt": 1594243850,
  "lastCreatedAt": 1594243850,
  "currentStep": 0,
  "totalStep": 100
}
```

### Error Response Example

```json
{
  "type": "Bad Request",
  "title": "Bad Request Error",
  "status": 400,
  "detail": "Validation failed. Missing payload.",
  "instance": "/v2.0/flows/5ce7c2d833ea1e04d7e6c432",
  "code": 1000,
  "traceId": "api--f84324f4-98eb-4f02-abdd-375a2e6c3c1f",
  "details": {}
}
```
